﻿using System;

using System.Web.Mvc;

using TweetSharp;

namespace Twitter.Controllers
{
    public class HomeController : Controller
    {
        private const string API_KEY = "cQKjSrT6ilBWfFgYShbD5XF2p";
        private const string SECRET = "d2jzpoJHyF8ZTVBgimJeoQWa4mJBCJWu9w8NdNaNOAMhUzkBSB";

        public ActionResult Index()
        {
            OAuthAccessToken accessToken = Session["AccessToken"] as OAuthAccessToken;
            if (accessToken != null)
            {
                return RedirectToAction("List");
            }

            return View();
        }


        public ActionResult Login()
        {
            // Step 1 - Retrieve an OAuth Request Token
            var service = new TwitterService(API_KEY, SECRET);

            // This is the registered callback URL
            OAuthRequestToken requestToken = service.GetRequestToken("http://www.pv247.com:1657/Home/AuthorizeCallback");

            // Step 2 - Redirect to the OAuth Authorization URL
            Uri uri = service.GetAuthorizationUri(requestToken);
            return new RedirectResult(uri.ToString(), false /*permanent*/);
        }

        // This URL is registered as the application's callback at http://dev.twitter.com
        public ActionResult AuthorizeCallback(string oauth_token, string oauth_verifier)
        {
            var requestToken = new OAuthRequestToken {Token = oauth_token};

            // Step 3 - Exchange the Request Token for an Access Token
            TwitterService service = new TwitterService(API_KEY, SECRET);
            OAuthAccessToken accessToken = service.GetAccessToken(requestToken, oauth_verifier);

            Session["AccessToken"] = accessToken;

            // Step 4 - User authenticates using the Access Token
            
            return RedirectToAction("List");
        }


        public ActionResult List()
        {
            OAuthAccessToken accessToken = Session["AccessToken"] as OAuthAccessToken;
            if (accessToken == null)
            {
                return RedirectToAction("Index");
            }

            TwitterService service = new TwitterService(API_KEY, SECRET);
            service.AuthenticateWith(accessToken.Token, accessToken.TokenSecret);
            TwitterUser user = service.VerifyCredentials(new VerifyCredentialsOptions());
            ViewBag.Message = string.Format("Your username is {0}", user.ScreenName);

            var statuses = service.ListTweetsOnUserTimeline(new ListTweetsOnUserTimelineOptions() {Count = 20});

            return View(statuses);
        }
    }
}